package kaysaar.aotd_question_of_loyalty.data.scripts.effectapplier;

import com.fs.starfarer.api.combat.MutableStat;
import com.fs.starfarer.api.campaign.CampaignFleetAPI;
import com.fs.starfarer.api.campaign.CustomCampaignEntityPlugin;
import java.util.Iterator;
import kaysaar.aotd_question_of_loyalty.data.misc.QoLMisc;
import com.fs.starfarer.api.impl.campaign.SensorArrayEntityPlugin;
import com.fs.starfarer.api.campaign.SectorEntityToken;
import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.EveryFrameScript;

public class AoTDSharedSensorLink implements EveryFrameScript
{
    public static String modifier;
    
    public boolean isDone() {
        return false;
    }
    
    public boolean runWhilePaused() {
        return false;
    }
    
    public void advance(final float amount) {
        if (Global.getSector().getPlayerFleet().getStarSystem() != null) {
            for (SectorEntityToken allEntity : Global.getSector().getPlayerFleet().getStarSystem().getAllEntities()) {
                final CustomCampaignEntityPlugin plugin = allEntity.getCustomPlugin();
                if (plugin instanceof SensorArrayEntityPlugin && QoLMisc.isCommissionedBy(allEntity.getFaction().getId())) {
                    float bonus = SensorArrayEntityPlugin.SENSOR_BONUS;
                    if (allEntity.hasTag("makeshift")) {
                        bonus = SensorArrayEntityPlugin.SENSOR_BONUS_MAKESHIFT;
                    }
                    final CampaignFleetAPI fleet = Global.getSector().getPlayerFleet();
                    final MutableStat.StatMod curr = fleet.getStats().getSensorRangeMod().getFlatBonus("sensor_array");
                    if (curr != null && curr.value > bonus) {
                        continue;
                    }
                    fleet.getStats().addTemporaryModFlat(0.1f, "sensor_array", "Sensor Array (" + allEntity.getFaction().getDisplayName(), bonus, fleet.getStats().getSensorRangeMod());
                }
            }
        }
    }
    
    static {
        AoTDSharedSensorLink.modifier = "$aotd_commision_shaared_array";
    }
}
